/* Extract Uncrackable Password, rar 29-08-2000 */

/****************************************************************************
 * $Id: pwd_pot.c,v 1.12 2003/06/11 22:30:41 ralproth Exp $
 *
 * $Log: pwd_pot.c,v $
 * Revision 1.12  2003/06/11 22:30:41  ralproth
 * Changes made in Brechen for TimeDate on Win98
 *
 * Revision 1.11  2003/03/24 20:14:56  ralph
 * pwd_pot.c:225: warning: passing arg 2 of `strcpy' makes pointer from integer wit
 * hout a cast
 *
 * Revision 1.10  2003/01/26 17:30:58  ralph
 * Fixes and first hash strategy added
 *
 * Revision 1.9  2003/01/07 18:17:14  ralph
 * New Makefiles added
 *
 * Revision 1.8  2003/01/03 20:56:17  ralph
 * more fixes (LCC-32)
 * new pwd_pot.c
 *
 * Revision 1.7  2003/01/03 15:39:09  ralph
 * ! Makefile enhanced
 * ! y2k3 + copyrigth
 * ! Samba/LM fixes
 *
 * Revision 1.6  2002/04/15 12:39:23  ralph
 * Added password_filter.lex handling
 *
 * Revision 1.5  2002/04/15 10:53:10  ralph
 * NT LM hashes + spell fixing
 *
 * Revision 1.4  2002/04/11 17:33:28  ralph
 * Replaced Header with ID (for WinCVS)
 *
 * Revision 1.3  2002/02/07 21:31:34  ralph
 * fixed typo
 *
 * Revision 1.2  2002/01/03 12:59:01  ralph
 * Fixed various bugs found in MergePasswords and other tools
 *
 *
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/


//static char *_CMSID = "$CmsFile: xtr_uncrackables.c $ $Date: 2003/06/11 22:30:41 $";

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* Prototypes */
void XtractUncrackablePasswords(char*, char*);

#ifdef __LCC__
char *index (char *s, int c);
char *strsep(char **pp, const char *delim);
#endif

#define MAXVALHASH 0x7fff

struct salt_type {
	char user[60], salt[33];		/* 32 = NT LM Hash */
	long id, gid;
	char info[120], home[120], shell[120];

	struct salt_type *next;
};

struct salt_type *current, *salt_hash[MAXVALHASH];

long lCntr = 0;

int salt_hashfunc(struct salt_type *s)
{

	int  h;

	if (strlen(s->salt) < 8)
		return 0;

	h = s->salt[0];
	h <<= 4;
	h = h + s->salt[3];
	return h &= MAXVALHASH;
}

/*------------------------------------------------------------------------
Procedure:     exists_salt_hash ID:1
Purpose:       Checks if hash is already in the hash table

Input:
Output:
Errors:
------------------------------------------------------------------------*/
int exists_salt_hash(struct salt_type *sin)
{
	current = salt_hash[salt_hashfunc(sin)];

	while (current != NULL)
	{
		if (strcmp(sin->salt, current->salt) == 0)
		{
			return -1;
		}
		current = current->next;
	}

	return 0;

} /* exists_salt_hash() */

/*------------------------------------------------------------------------
Procedure:     ins_salt_hash ID:1
Purpose:       Inserts a new hash struct
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ins_salt_hash(struct salt_type *s)
{

	/* printf("|%s|%s|%s|\n", s->user, s->salt, s->info); */

	int nsalt_hash = salt_hashfunc(s);

	if (exists_salt_hash(s) )
		return;

	current = salt_hash[nsalt_hash];

	if ((salt_hash[nsalt_hash]=malloc(sizeof(struct salt_type)))==NULL)
	{
		puts("\nFATAL: Out of memory! Aborting!");
		exit(2);
	}

	memcpy(salt_hash[nsalt_hash], s, sizeof(struct salt_type));
	salt_hash[nsalt_hash]->next = current;

	lCntr++;

} /* ins_salt_hash() */


int read_jackpot(char *szSrc, char cDel)
{
	FILE *hIn;
	char s[256];
	char *p;
	struct salt_type  sTmp;

	if ((hIn=fopen(szSrc,"r")) == NULL)
	{
		perror(szSrc);
		return -1;
	}

	while (!feof(hIn)) {
		fgets(s, sizeof(s), hIn);
		if ((p = strchr(s, '\r')) != NULL) *p = 0;
		if ((p = strchr(s, '\n')) != NULL) *p = 0;
		if (!(p = strchr(s, cDel))) continue;
		*p = 0;
		p++;

		sTmp.user[0] = 0;
		strcpy(sTmp.salt, s);

		if (!exists_salt_hash(&sTmp))
			ins_salt_hash(&sTmp);
	}
	fclose(hIn);

	printf("%-14s \t%7ld passwords read from pot.\n", szSrc, lCntr);
	fflush(stdout);
	lCntr = 0;

	return 0;

}  /* read_jackpot() */


int read_passwordfile(char *szSrc)
{
	FILE 	*hIn;
	char 	s[1024], *sp, c1, s2[40], szTmp[1024];
	char 	*p, gid[10], id[10];
	long 	lCountOld = lCntr;
	struct 	salt_type  sTmp;
	int	nRetCode;

	if ((hIn=fopen(szSrc,"r")) == NULL)
	{
		perror(szSrc);
		return -1;
	}
//        yyin = hIn;                           	/* use file as stdin! */
//        yyrestart(yyin);                      	/* restart machine */

	while (!feof(hIn)) {
                fgets(s, sizeof(s), hIn);

// 	while ((nRetCode = yylex()) != 0) 	/* 0 = eof */
// 	{

	/* fetch it from password-lex function in future */
	/* if (fgets(s, sizeof(s), hIn) == NULL) continue; */

//	if (nRetCode == GOODPWL)
//	{
//		strcpy(s, yytext);

		if ((p = strchr(s, '\r')) != NULL) *p = 0;
		if ((p = strchr(s, '\n')) != NULL) *p = 0;
		if (!(p = strstr(s, ":"))) continue;
		if (strlen(s) > 256) continue;
		if (strlen(s) < 24) continue;

		sp = s;
		strcpy(szTmp, strsep(&sp, ":"));
		if (strlen(szTmp) >= sizeof(sTmp.user)) continue;
		if (strlen(szTmp) < 1) continue;
		strcpy(sTmp.user, szTmp);
/* TODO (ralph#4#): pwd_pot.c:225: warning: passing arg 2 of `strcpy' 
                    makes pointer from integer without a cast */
		strcpy(szTmp, strsep(&sp, ":"));
		if (strlen(szTmp) >= sizeof(sTmp.salt)) continue;
		if (strlen(szTmp) < 12) continue;

		strcpy(s2, szTmp);   		  /* index */
		if (s2[13] == ',')		         /* password aging? */
			s2[13] = 0;

		strcpy(sTmp.salt, s2);
		strcpy(id, strsep(&sp, ":"));
		strcpy(gid, strsep(&sp, ":"));
		strcpy(sTmp.info, strsep(&sp, ":"));
		strcpy(sTmp.home, strsep(&sp, ":"));
		strcpy(sTmp.shell, strsep(&sp, ":\n\r"));

		sTmp.id = atol(id);
		sTmp.gid = atol(gid);

		strcpy(s2, "##");
		strcat(s2, sTmp.user);
		c1 = sTmp.salt[0];      	/* locked passwd? */

		if (strlen(sTmp.salt) > 4)
		{
			/* printf("%s %s %s\n", sTmp.user, sTmp.salt, sTmp.info); */
			if ((!exists_salt_hash(&sTmp)) && \
            			(index("!-?*", c1)==NULL) && (strcmp(s2, sTmp.salt) != 0))
				ins_salt_hash(&sTmp);
		} /* if */

	   } /* if GOODPWL */
//	}
	fclose(hIn);

	printf("%-14s \t%7ld new passwords added (%ld total).\n", \
           szSrc, lCntr-lCountOld, lCntr);

	return 0;

}  /* read_passwordfile() */

void write_passwordfile(char *szFile)
{
	int   t;
	FILE *hOut;

	if ((hOut=fopen(szFile,"wt")) != NULL)
	{

		for (t=0; t<=MAXVALHASH; t++)
		{
			current = salt_hash[t];

			while (current != NULL)
			{
				if (strlen(current->user) > 0)
					fprintf(hOut, "%s:%s:%ld:%ld:%s:%s:%s\n", \
                              	current->user, current->salt, \
                              	current->id, current->gid, \
                              	current->info, current->home, current->shell);

				current = current->next;
			}
		}
		fclose(hOut);
	}

} /* write_passwordfile() */

void XtractUncrackablePasswords(char *szFile, char *szRes)
{
        memset(salt_hash, 0, sizeof(salt_hash));

        read_jackpot("Cracked.pot", '|');
        read_jackpot("jack.pot", ':');
        read_jackpot("john.pot", ':');

        read_passwordfile(szFile);

        printf("Writeing back cummulated password file (%s, %ld password)\n", szRes, lCntr);
        write_passwordfile(szRes);

} /* XtractUncrackablePassowrds  */



#ifdef WITH_MAIN
int main(int argc, char *argv[])
{
	char   szFile[256];

	printf("Uncrackable Password Extractor (%s)\nVersion $Id: pwd_pot.c,v 1.12 2003/06/11 22:30:41 ralproth Exp $\n",  __DATE__);
	memset(salt_hash, 0, sizeof(salt_hash));

	if (argc < 2) {
		puts("Usage: 	xtr_uncrackables  inputfile(s)");
		return 1;
	}

	read_jackpot("Cracked.pot", '|');
	read_jackpot("jack.pot", ':');
	read_jackpot("john.pot", ':');

	/* for debugging */
	puts("Jackpots processed, reading now the password file(s) ...");

	while (--argc>0) {
		strcpy(szFile, argv[argc]);
		printf("Reading file %s\n", szFile);
		fflush(stdout);
		read_passwordfile(szFile);
		/* puts("-- OK! --"); */
	}
	printf("Writing back cummulated password file (uncracked.pw, %ld password)\n", Cnt);
	write_passwordfile("uncracked.pw");

	return 0;
}
#endif

