/* sfccrypt.c
 * too slow on intel machines!
 * -------------------------------------------------------------------------
 * 100000 tests, 58.0 seconds = 1723.5 pure crypt()'s/seconds, PMMX, 200 MHz
 * -------------------------------------------------------------------------
 *  SFCCRYPT
 * TinyCrack/Brute -=- 0.91.5 -=- (c) by ROSE SWE -=- [Aug 29 2002]  -? = he
 *
 * Performing pure crypt() benchmark test on 100000 crypts...
 * 100000 tests, 43.6 seconds = 2292.2 pure crypt()'s/seconds
 * The crypt() speed will be higher due to the use of the pot file
 * and hash functions.
 *
 *  CRACK-FC
 * TinyCrack/Brute -=- 0.91.5 -=- (c) by ROSE SWE -=- [Aug 29 2002]  -? = he
 *
 * Performing pure crypt() benchmark test on 100000 crypts...
 * 100000 tests, 14.5 seconds = 6920.2 pure crypt()'s/seconds
 * The crypt() speed will be higher due to the use of the pot file
 * and hash functions.
 *
 *
 */
#include <string.h>

static char *rcsid = "@(#)SFC-crypt $Header: /home/CVS/c/TinyCrack/Source/TinyCrack/sfccrypt.c,v 1.2 2002/08/29 17:22:32 ralph Exp $";

typedef unsigned int bit32;
typedef unsigned short bit16;
typedef unsigned char bit8;

/* Macro to set a bit (0..23)
 */
#define BITMASK(i) ( (1<<(11-(i)%12+3)) << ((i)<12?16:0) )

/* lookup a 6 bit value in sbox
 */
#define s_lookup(i,s) sbox[(i)][(((s)>>4) & 0x2)|((s) & 0x1)][((s)>>1) & 0xf];

/* Permutation done once on the 56 bit
 * key derived from the original 8 byte ASCII key.
 */
static int pc1[56] =
{ 57, 49, 41, 33, 25, 17,  9,  1, 58, 50, 42, 34, 26, 18,
  10,  2, 59, 51, 43, 35, 27, 19, 11,  3, 60, 52, 44, 36,
  63, 55, 47, 39, 31, 23, 15,  7, 62, 54, 46, 38, 30, 22,
  14,  6, 61, 53, 45, 37, 29, 21, 13,  5, 28, 20, 12,  4
};

/* How much to rotate each 28 bit half of the pc1 permutated
 * 56 bit key before using pc2 to give the i' key
 */
static int rots[16] =
{  1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1
};

/* Permutation giving the key of the i'th DES round
 */
static int pc2[48] =
{ 14, 17, 11, 24,  1,  5,  3, 28, 15,  6, 21, 10,
  23, 19, 12,  4, 26,  8, 16,  7, 27, 20, 13,  2,
  41, 52, 31, 37, 47, 55, 30, 40, 51, 45, 33, 48,
  44, 49, 39, 56, 34, 53, 46, 42, 50, 36, 29, 32
};

/* The E expansion table which selects
 * bits from the 32 bit intermediate result.
 */
static int esel[48] =
{ 32,  1,  2,  3,  4,  5,  4,  5,  6,  7,  8,  9,
   8,  9, 10, 11, 12, 13, 12, 13, 14, 15, 16, 17,
  16, 17, 18, 19, 20, 21, 20, 21, 22, 23, 24, 25,
  24, 25, 26, 27, 28, 29, 28, 29, 30, 31, 32,  1
};

static int e_inverse[64];

/* Permutation done on the result of sbox lookups
 */
static int perm32[32] =
{ 16,  7, 20, 21, 29, 12, 28, 17,  1, 15, 23, 26,  5, 18, 31, 10,
  2,   8, 24, 14, 32, 27,  3,  9, 19, 13, 30,  6, 22, 11,  4, 25
};

/* The sboxes
 */
static int sbox[8][4][16]=
{ { { 14,  4, 13,  1,  2, 15, 11,  8,  3, 10,  6, 12,  5,  9,  0,  7 },
    {  0, 15,  7,  4, 14,  2, 13,  1, 10,  6, 12, 11,  9,  5,  3,  8 },
    {  4,  1, 14,  8, 13,  6,  2, 11, 15, 12,  9,  7,  3, 10,  5,  0 },
    { 15, 12,  8,  2,  4,  9,  1,  7,  5, 11,  3, 14, 10,  0,  6, 13 }
  },
  { { 15,  1,  8, 14,  6, 11,  3,  4,  9,  7,  2, 13, 12,  0,  5, 10 },
    {  3, 13,  4,  7, 15,  2,  8, 14, 12,  0,  1, 10,  6,  9, 11,  5 },
    {  0, 14,  7, 11, 10,  4, 13,  1,  5,  8, 12,  6,  9,  3,  2, 15 },
    { 13,  8, 10,  1,  3, 15,  4,  2, 11,  6,  7, 12,  0,  5, 14,  9 }
  },
  { { 10,  0,  9, 14,  6,  3, 15,  5,  1, 13, 12,  7, 11,  4,  2,  8 },
    { 13,  7,  0,  9,  3,  4,  6, 10,  2,  8,  5, 14, 12, 11, 15,  1 },
    { 13,  6,  4,  9,  8, 15,  3,  0, 11,  1,  2, 12,  5, 10, 14,  7 },
    {  1, 10, 13,  0,  6,  9,  8,  7,  4, 15, 14,  3, 11,  5,  2, 12 }
  },
  { {  7, 13, 14,  3,  0,  6,  9, 10,  1,  2,  8,  5, 11, 12,  4, 15 },
    { 13,  8, 11,  5,  6, 15,  0,  3,  4,  7,  2, 12,  1, 10, 14,  9 },
    { 10,  6,  9,  0, 12, 11,  7, 13, 15,  1,  3, 14,  5,  2,  8,  4 },
    {  3, 15,  0,  6, 10,  1, 13,  8,  9,  4,  5, 11, 12,  7,  2, 14 }
  },
  { {  2, 12,  4,  1,  7, 10, 11,  6,  8,  5,  3, 15, 13,  0, 14,  9 },
    { 14, 11,  2, 12,  4,  7, 13,  1,  5,  0, 15, 10,  3,  9,  8,  6 },
    {  4,  2,  1, 11, 10, 13,  7,  8, 15,  9, 12,  5,  6,  3,  0, 14 },
    { 11,  8, 12,  7,  1, 14,  2, 13,  6, 15,  0,  9, 10,  4,  5,  3 }
  },
  { { 12,  1, 10, 15,  9,  2,  6,  8,  0, 13,  3,  4, 14,  7,  5, 11 },
    { 10, 15,  4,  2,  7, 12,  9,  5,  6,  1, 13, 14,  0, 11,  3,  8 },
    {  9, 14, 15,  5,  2,  8, 12,  3,  7,  0,  4, 10,  1, 13, 11,  6 },
    {  4,  3,  2, 12,  9,  5, 15, 10, 11, 14,  1,  7,  6,  0,  8, 13 }
  },
  { {  4, 11,  2, 14, 15,  0,  8, 13,  3, 12,  9,  7,  5, 10,  6,  1 },
    { 13,  0, 11,  7,  4,  9,  1, 10, 14,  3,  5, 12,  2, 15,  8,  6 },
    {  1,  4, 11, 13, 12,  3,  7, 14, 10, 15,  6,  8,  0,  5,  9,  2 },
    {  6, 11, 13,  8,  1,  4, 10,  7,  9,  5,  0, 15, 14,  2,  3, 12 }
  },
  { { 13,  2,  8,  4,  6, 15, 11,  1, 10,  9,  3, 14,  5,  0, 12,  7 },
    {  1, 15, 13,  8, 10,  3,  7,  4, 12,  5,  6, 11,  0, 14,  9,  2 },
    {  7, 11,  4,  1,  9, 12, 14,  2,  0,  6, 10, 13, 15,  3,  5,  8 },
    {  2,  1, 14,  7,  4, 10,  8, 13, 15, 12,  9,  0,  3,  5,  6, 11 }
  }
};

/* This is the initial permutation matrix
 */
static int initial_perm[64] =
{ 58, 50, 42, 34, 26, 18, 10,  2, 60, 52, 44, 36, 28, 20, 12, 4,
  62, 54, 46, 38, 30, 22, 14,  6, 64, 56, 48, 40, 32, 24, 16, 8,
  57, 49, 41, 33, 25, 17,  9,  1, 59, 51, 43, 35, 27, 19, 11, 3,
  61, 53, 45, 37, 29, 21, 13,  5, 63, 55, 47, 39, 31, 23, 15, 7
};

/* This is the final permutation matrix
 */
static int final_perm[64] =
{ 40,  8, 48, 16, 56, 24, 64, 32, 39,  7, 47, 15, 55, 23, 63, 31,
  38,  6, 46, 14, 54, 22, 62, 30, 37,  5, 45, 13, 53, 21, 61, 29,
  36,  4, 44, 12, 52, 20, 60, 28, 35,  3, 43, 11, 51, 19, 59, 27,
  34,  2, 42, 10, 50, 18, 58, 26, 33,  1, 41,  9, 49, 17, 57, 25
};

/* The 16 DES keys in BITMASK format
 */
static bit32 KS[16][2];

/* sb arrays:
 * Workhorses of the inner loop of the DES implementation.
 * They do sbox lookup, shifting of this value, 32 bit
 * permutation and E permutation for the next round.
 * Kept in 'BITMASK' format.
 */

static bit32 sb0[8192], sb1[8192], sb2[8192], sb3[8192];
static bit32 *sb[4] = {sb0, sb1, sb2, sb3};

/* eperm32tab: do 32 bit permutation and E selection
 * The first index is the byte number in the 32 bit value to be permuted
 *  -  second  -   is the value of this byte
 *  -  third   -   selects the two 32 bit values
 * The table is used and generated internally in sfc_init_des to speed it up
 */
static bit32 eperm32tab[4][256][2];

/* do_pc1: permform pc1 permutation in the key schedule generation.
 * The first   index is the byte number in the 8 byte ASCII key
 *  -  second    -      -    the two 28 bits halfs of the result
 *  -  third     -   selects the 7 bits actually used of each byte
 * The result is kept with 28 bit per 32 bit with the 4 most significant
 * bits zero.
 */
static bit32 do_pc1[8][2][128];

/* do_pc2: permform pc2 permutation in the key schedule generation.
 * The first   index is the septet number in the two 28 bit intermediate values
 *  -  second    -    -  -  septet values
 * Knowledge of the structure of the pc2 permutation is used.
 * The result is kept with 28 bit per 32 bit with the 4 most significant
 * bits zero.
 */
static bit32 do_pc2[8][128];

/* efp: undo an extra e selection & do final permutation giving DES result.
 *      Invoked 6 bits at a time on two 48 bit values giving two 32 bit longs.
 */
static bit32 efp[16][64][2];

static bit8 bytemask[8]  = {
  0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01
};

static bit32 longmask[32] = {
  0x80000000, 0x40000000, 0x20000000, 0x10000000,
  0x08000000, 0x04000000, 0x02000000, 0x01000000,
  0x00800000, 0x00400000, 0x00200000, 0x00100000,
  0x00080000, 0x00040000, 0x00020000, 0x00010000,
  0x00008000, 0x00004000, 0x00002000, 0x00001000,
  0x00000800, 0x00000400, 0x00000200, 0x00000100,
  0x00000080, 0x00000040, 0x00000020, 0x00000010,
  0x00000008, 0x00000004, 0x00000002, 0x00000001
};

static int initialized = 0;
static bit8 current_salt[3] = "&&"; /* invalid value */
static bit32 current_saltbits = 0;
static int direction = 0;

/* Initialize unit
 */
void sfc_init_des()
{   register int        bit;
    register bit32      mask1, mask2;

/* Create do_pc1 table used to affect pc1 permutation when generating keys */
  { register bit32      frst;
    register bit32      comes_from;
    register bit32      j;

    for (bit = 28; bit--; )
    { comes_from = pc1[bit] - 1;
      mask1 = bytemask[(comes_from & 0x7) + 1];
      mask2 = longmask[bit + 4];
      frst = comes_from >> 3;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc1[frst][0][j] |= mask2;
    }
    for (bit = 28; bit < 56; bit++)
    { comes_from = pc1[bit] - 1;
      mask1 = bytemask[(comes_from & 0x7) + 1];
      mask2 = longmask[bit - 24];
      frst = comes_from >> 3;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc1[frst][1][j] |= mask2;
    }

/* Create do_pc2 table used to affect pc2 permutation when generating keys */
    for (bit = 12; bit--; )
    { comes_from = pc2[bit] - 1;
      mask1 = bytemask[comes_from % 7 + 1];
      mask2 = 1 << (30 - bit);
      frst = comes_from / 7;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc2[frst][j] |= mask2;
    }
    for (bit = 12; bit < 24; bit++)
    { comes_from = pc2[bit] - 1;
      mask1 = bytemask[comes_from % 7 + 1];
      mask2 = 1 << (26 - bit);
      frst = comes_from / 7;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc2[frst][j] |= mask2;
    }
    for (bit = 24; bit < 36; bit++)
    { comes_from = pc2[bit] - 1;
      mask1 = bytemask[comes_from % 7 + 1];
      mask2 = 1 << (54 - bit);
      frst = comes_from / 7;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc2[frst][j] |= mask2;
    }
    for (bit = 36; bit < 48; bit++)
    { comes_from = pc2[bit] - 1;
      mask1 = bytemask[comes_from % 7 + 1];
      mask2 = 1 << (50 - bit);
      frst = comes_from / 7;
      for (j = 128; j--; )
        if (j & mask1)
          do_pc2[frst][j] |= mask2;
    }

/* Generate table for combined bit32 permutation and e expansion used to
* permute 16384 bit32's into bit48's to initialize sb.
*/
    memset((bit8*)eperm32tab, '\0', sizeof(eperm32tab));
    for (bit = 0; bit < 12; bit++)
    { comes_from = perm32[esel[bit] -1] -1;
      mask1 = bytemask[comes_from & 0x7];
      mask2 = 1 << (30 - bit);
      frst = comes_from >> 3;
      for (j = 256; j--; )
        if (j & mask1)
          eperm32tab[frst][j][0] |= mask2;
    }
    for (bit = 12; bit < 24; bit++)
    { comes_from = perm32[esel[bit] -1] -1;
      mask1 = bytemask[comes_from & 0x7];
      mask2 = 1 << (26 - bit);
      frst = comes_from >> 3;
      for (j = 256; j--; )
        if (j & mask1)
          eperm32tab[frst][j][0] |= mask2;
    }
    for (bit = 24; bit < 36; bit++)
    { comes_from = perm32[esel[bit] -1] -1;
      mask1 = bytemask[comes_from & 0x7];
      mask2 = 1 << (54 - bit);
      frst = comes_from >> 3;
      for (j = 256; j--; )
        if (j & mask1)
          eperm32tab[frst][j][1] |= mask2;
    }
    for (bit = 36; bit < 48; bit++)
    { comes_from = perm32[esel[bit] -1] -1;
      mask1 = bytemask[comes_from & 0x7];
      mask2 = 1 << (50 - bit);
      frst = comes_from >> 3;
      for (j = 256; j--; )
        if (j & mask1)
          eperm32tab[frst][j][1] |= mask2;
    }
  }

/* Create sb tables for each bit12 segment of an bit48 intermediate result.
* The sb table precomputes two bit4 values for sbox lookups done with two bit6
* halves, shifts them to the proper place, sends them through perm32 and
* 'E' expands to be ready for the next DES round.
*/
  { register int        sg;
    register int        j1, j2;
    register int        s1, s2;
    register bit32      to_permute, inx;

    for (sg = 4; sg--; )
    { for (j1 = 64; j1--; )
      { s1 = s_lookup(sg << 1, j1);
        for (j2 = 64; j2--; )
        { s2 = s_lookup((sg << 1) + 1, j2);
          to_permute = ((s1 << 4)  | s2) << (24 - (sg << 3));
          inx = ((j1 << 6)  | j2) << 1;
          sb[sg][inx++]  = eperm32tab[0][(to_permute >> 24) & 0xff][0];
          sb[sg][inx--]  = eperm32tab[0][(to_permute >> 24) & 0xff][1];
          sb[sg][inx++] |= eperm32tab[1][(to_permute >> 16) & 0xff][0];
          sb[sg][inx--] |= eperm32tab[1][(to_permute >> 16) & 0xff][1];
          sb[sg][inx++] |= eperm32tab[2][(to_permute >>  8) & 0xff][0];
          sb[sg][inx--] |= eperm32tab[2][(to_permute >>  8) & 0xff][1];
          sb[sg][inx++] |= eperm32tab[3][(to_permute)       & 0xff][0];
          sb[sg][inx  ] |= eperm32tab[3][(to_permute)       & 0xff][1];
        }
      }
    }
  }

/* Create inverse matrix for esel with where to extract bits when undoing */
    for (bit = 48; bit--;)
    { e_inverse[esel[bit] - 1 ] = bit;
      e_inverse[esel[bit] + 31] = bit + 48;
    }

  { register int        o_bit, o_long;
    register bit32      word_value;
    register int        comes_from_f_bit, comes_from_e_bit;
    register int        comes_from_word, bit_within_word;

/* create efp matrix used to undo 'e' expansion and affect final permutation */
    memset((bit8*)efp, '\0', sizeof efp);
    for (bit = 64; bit--; )

/* See where bit i belongs in the two 32 bit long's */
    { o_long = bit >> 5;        /* 0..1  */
      o_bit  = bit & 0x1f;      /* 0..31 */

/* Find bit in 'e' permuted value setting this bit.  'e' selection may
* have selected the same bit several times.  Initialization of e_inverse
* causes finding only one instance.
*/
/*    comes_from_f_bit = final_perm[bit] - 1; */         /* 0..63 */
      comes_from_e_bit = e_inverse[final_perm[bit] - 1]; /* 0..95 */
      comes_from_word  = comes_from_e_bit / 6;           /* 0..15 */
      bit_within_word  = comes_from_e_bit % 6;           /* 0..5  */

      mask1 = longmask[bit_within_word + 26];
      mask2 = longmask[o_bit];

      for (word_value = 64; word_value--; )
        if (word_value & mask1)
          efp[comes_from_word][word_value][o_long] |= mask2;
    }
  }
    initialized++;
}

/* Setup the unit for a new salt
 * Hopefully we'll not see a new salt in each crypt call.
 */
static void setup_salt(s)
register bit8   *s;
{   register bit32      j, saltbits;

    if (!initialized)
      sfc_init_des();

    if (s[0] == current_salt[0] && s[1] == current_salt[1])
      return;
    current_salt[0] = s[0];
    current_salt[1] = s[1];

/* Customize DES for crypt here!  Swap Entries in expansion table according to
* bits set in salt.
*/
    saltbits = 0;
    { register int      c;
      c = s[0] >= 'a' ? s[0]-59 : s[0] >= 'A' ? s[0]-53 : s[0]-'.';
      if (c < 0 || c > 63)
        c = 0;
      for (j = 0; j < 6; j++)
        if ((c >> j) & 0x1)
          saltbits |= BITMASK(j);
      c = s[1] >= 'a' ? s[1]-59 : s[1] >= 'A' ? s[1]-53 : s[1]-'.';
      if (c < 0 || c > 63)
        c = 0;
      for (j = 0; j < 6; j++)
        if ((c >> j) & 0x1)
          saltbits |= BITMASK(6 + j);
    }

/* Permute sb table values using changed 'e' selection table
*/
  { register bit32      *rsb0=sb0, *rsb1=sb1, *rsb2=sb2, *rsb3=sb3;
    register bit32      x, rsaltbits = current_saltbits ^ saltbits;

/* Process the elements of the sb table permuting the
 * bits swapped in the expansion by the current salt.
 */
    for (j=4096; j--; )
    { x = (rsb0[0] ^ rsb0[1]) & rsaltbits;
      *rsb0++ ^= x;
      *rsb0++ ^= x;
    }
    for (j=4096; j--; )
    { x = (rsb1[0] ^ rsb1[1]) & rsaltbits;
      *rsb1++ ^= x;
      *rsb1++ ^= x;
    }
    for (j=4096; j--; )
    { x = (rsb2[0] ^ rsb2[1]) & rsaltbits;
      *rsb2++ ^= x;
      *rsb2++ ^= x;
    }
    for (j=4096; j--; )
    { x = (rsb3[0] ^ rsb3[1]) & rsaltbits;
      *rsb3++ ^= x;
      *rsb3++ ^= x;
    }
  }
    current_saltbits = saltbits;
}

static void sfc_mk_keytab(key)
register bit8   *key;
{   register bit32      v1=0, v2=0, *k1=(bit32 *)do_pc1, v, *k2=(bit32 *)KS;
    register int        i;

    for (i = 8; i--; )
    { v1 |= k1[*key   & 0x7f];
      k1 += 128;
      v2 |= k1[*key++ & 0x7f];
      k1 += 128;
    }

    for (i = 0; i < 16; i++)
    { k1 = (bit32 *)do_pc2;
      v1 = (v1 << rots[i]) | (v1 >> (28 - rots[i]));
      v  = k1[(v1 >> 21) & 0x7f];
      k1 += 128;
      v |= k1[(v1 >> 14) & 0x7f];
      k1 += 128;
      v |= k1[(v1 >>  7) & 0x7f];
      k1 += 128;
      v |= k1[(v1      ) & 0x7f];
      k1 += 128;
      *k2++ = v;
      v2 = (v2 << rots[i]) | (v2 >> (28 - rots[i]));
      v  = k1[(v2 >> 21) & 0x7f];
      k1 += 128;
      v |= k1[(v2 >> 14) & 0x7f];
      k1 += 128;
      v |= k1[(v2 >>  7) & 0x7f];
      k1 += 128;
      v |= k1[(v2      ) & 0x7f];
      *k2++ = v;
    }
    direction = 0;
  }

/* Undo an extra E selection and do final permutations
 */
static bit32 *sfc_dofinalperm(Ll, Lh, Rl, Rh)
register bit32  Ll,Lh,Rl,Rh;
{   register bit32      v1=0, v2=0, x;
    static bit32        ary[2];

    x = (Ll ^ Lh) & current_saltbits;
    Ll ^= x;
    Lh ^= x;
    x = (Rl ^ Rh) & current_saltbits;
    Rl ^= x;
    Rh ^= x;

    Ll >>= 3;
    Lh >>= 3;
    Rl >>= 3;
    Rh >>= 3;

    v1 |= efp[15][ Rh         & 0x3f][0];
    v2 |= efp[15][ Rh & 0x3f][1];
    v1 |= efp[14][(Rh >>= 6)  & 0x3f][0];
    v2 |= efp[14][ Rh & 0x3f][1];
    v1 |= efp[13][(Rh >>= 10) & 0x3f][0];
    v2 |= efp[13][ Rh & 0x3f][1];
    v1 |= efp[12][(Rh >>= 6)  & 0x3f][0];
    v2 |= efp[12][ Rh & 0x3f][1];

    v1 |= efp[11][ Rl         & 0x3f][0];
    v2 |= efp[11][ Rl & 0x3f][1];
    v1 |= efp[10][(Rl >>= 6)  & 0x3f][0];
    v2 |= efp[10][ Rl & 0x3f][1];
    v1 |= efp[ 9][(Rl >>= 10) & 0x3f][0];
    v2 |= efp[ 9][ Rl & 0x3f][1];
    v1 |= efp[ 8][(Rl >>= 6)  & 0x3f][0];
    v2 |= efp[ 8][ Rl & 0x3f][1];

    v1 |= efp[ 7][ Lh         & 0x3f][0];
    v2 |= efp[ 7][ Lh & 0x3f][1];
    v1 |= efp[ 6][(Lh >>= 6)  & 0x3f][0];
    v2 |= efp[ 6][ Lh & 0x3f][1];
    v1 |= efp[ 5][(Lh >>= 10) & 0x3f][0];
    v2 |= efp[ 5][ Lh & 0x3f][1];
    v1 |= efp[ 4][(Lh >>= 6)  & 0x3f][0];
    v2 |= efp[ 4][ Lh & 0x3f][1];

    v1 |= efp[ 3][ Ll         & 0x3f][0];
    v2 |= efp[ 3][ Ll & 0x3f][1];
    v1 |= efp[ 2][(Ll >>= 6)  & 0x3f][0];
    v2 |= efp[ 2][ Ll & 0x3f][1];
    v1 |= efp[ 1][(Ll >>= 10) & 0x3f][0];
    v2 |= efp[ 1][ Ll & 0x3f][1];
    v1 |= efp[ 0][(Ll >>= 6)  & 0x3f][0];
    v2 |= efp[ 0][ Ll & 0x3f][1];

    ary[0] = v1;
    ary[1] = v2;
    return ary;
  }

/* crypt only: convert from 64 bit to 11 bit6 ASCII prefixing with the salt */
static bit8 *output_conversion(v1, v2, salt)
register bit32  v1, v2;
register bit8   *salt;
{   static bit8         outbuf[14];
    register bit8       *rout;
    register int           s;
    register bit32      c;

    rout=outbuf;
    s  = (v2 & 0xf) << 2;
    v2 = (v2 >> 2) | ((v1 & 0x3) << 30);
    *rout++ = salt[0];
    *rout++ = salt[1] ? salt[1] : salt[0];
    c = (v1 >> 26) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v1 >> 20) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v1 >> 14) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v1 >>  8) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v1 >>  2) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v2 >> 26) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v2 >> 20) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v2 >> 14) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v2 >>  8) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    c = (v2 >>  2) & 0x3f;
    *rout++ = c >= 38 ? (c-38+'a') : c >= 12 ? (c-12+'A') : c+'.';
    *rout++ = s >= 38 ? (s-38+'a') : s >= 12 ? (s-12+'A') : s+'.';
    *rout++ = 0;
    return outbuf;
  }

/* UNIX crypt function
 */

extern bit8 *crypt(key, salt)
  bit8 *key, *salt;
  { bit32 *s;
    bit8 ktab[9];

    /* Hack DES tables according to salt
     */
    setup_salt(salt);

    /* Setup key schedule
     */
    (void)strncpy(ktab, key, 8);
    sfc_mk_keytab(ktab);

    /* Do 25 DES encryptions */
{
    register bit32 wrd;       /*  4 asn 4 shf 4 idx/inc 4 idx */
    register bit32 idx;       /*  4 asn       4 idx/inc 4 idx */
    register bit32 *j;        /*  4 ref/inc */
    register bit32 *rsb0=sb0; /*  4 ref */
    register bit32 *rsb1=sb1; /*  4 ref */
    register bit32 *rsb2=sb2; /*  4 ref */
    register bit32 *rsb3=sb3; /*  4 ref */
    register bit32 Ll=0;      /*  2 asn 1 use */
    register bit32 Lh=0;      /*  2 asn 1 use */
    register bit32 Rl=0;      /*  2 asn 1 use */
    register bit32 Rh=0;      /*  2 asn 1 use */
    register int kloop;     /*  1 dec/tst */
    register int loop;

    for(loop=25; loop--; )
    { j = (bit32 *)KS;
      for(kloop=8; kloop--; )
      {
        idx = ((wrd = *j++ ^ Rl) & 0xffff) >> 2;
        Ll ^= rsb1[idx++];
        Lh ^= rsb1[idx];
        wrd >>= 18;
        Ll ^= rsb0[wrd++];
        Lh ^= rsb0[wrd];

        idx = ((wrd = *j++ ^ Rh) & 0xffff) >> 2;
        Ll ^= rsb3[idx++];
        Lh ^= rsb3[idx];
        wrd >>= 18;
        Ll ^= rsb2[wrd++];
        Lh ^= rsb2[wrd];

        idx = ((wrd = *j++ ^ Ll) & 0xffff) >> 2;
        Rl ^= rsb1[idx++];
        Rh ^= rsb1[idx];
        wrd >>= 18;
        Rl ^= rsb0[wrd++];
        Rh ^= rsb0[wrd];

        idx = ((wrd = *j++ ^ Lh) & 0xffff) >> 2;
        Rl ^= rsb3[idx++];
        Rh ^= rsb3[idx];
        wrd >>= 18;
        Rl ^= rsb2[wrd++];
        Rh ^= rsb2[wrd];
      }
      wrd=Ll; Ll=Rl; Rl=wrd; wrd=Lh; Lh=Rh; Rh=wrd;
    }
    s = sfc_dofinalperm(Ll, Lh, Rl, Rh);
}


    /* And convert back to 6 bit ASCII
     */
    return output_conversion(s[0], s[1], salt);
  }

/*
 * SFC-crypt: super ultra fast crypt(3) implementation
 *
 * Copyright (C) 1997, 1998, Free Software Foundation, Inc.
 *
 *
 * @(#)crypt_util.c     2.31 02/08/92
 *
 * Support routines
 *
 */

#ifdef WITH_FCRYPT
// extern char *crypt(const char *key, const char *salt);

/*
 * To make fcrypt users happy.
 * They don't need to call init_des.
 */

char *fcrypt(key, salt)
  char *key;
  char *salt;
  { return crypt(key, salt);
  }
#endif

/*
 * Initialize unit - may be invoked directly
 * by fcrypt users.
 * Dummy function to resolve external references in Crack.
 */

void init_des()
  { return;
  }

