

/****************************************************************************
 * $Id: gen_passwd.c,v 1.10 2005/01/09 19:04:03 ralproth Exp $
 *
 * $Log: gen_passwd.c,v $
 * Revision 1.10  2005/01/09 19:04:03  ralproth
 * Changes made in Zimmern and Brechen, y2k5 update
 *
 * Revision 1.9  2003/08/10 16:38:45  ralproth
 * New passgen.c: Bugfixing passwords greater that 8 chars
 *
 * Revision 1.4  2002/04/11 16:17:11  ralph
 * Dos2ux applied
 *
 * Revision 1.3  2002/04/11 16:16:07  ralph
 * Fixes for gcc 2.95 with -W
 *
 * Revision 1.2  2002/01/03 12:58:59  ralph
 * Fixed various bugs found in MergePasswords and other tools
 *
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/



/***
 * genpw.c
 *  - This program will generate encrypted password strings for
 *    use in adding passwords to executable programs.
 *    You must provide a two character salt and a password.
 *    to compile: gcc -s -O5 crack-fc.o -o genpw genpw.c
 *	or  gcc -s -O5 gen_passwd.c -o gen_passwd -lcrypt
 *
 ***/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>


/* From local_passwd.c (C) Regents of Univ. of California blah blah */
static unsigned char itoa64[] =         /* 0 ... 63 => ascii - 64 */
        "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

void to64(register char *s, register long v, register int n) {
    while (--n >= 0) {
        *s++ = itoa64[v&0x3f];
        v >>= 6;
    }
}


int main(void)
{
    char *pwe;
    char pw[32];
    char salt[4];
    char input[180], szTime[180];
    time_t t;

#ifdef oldstyle
    /* if used with Fast-Crypt */
    init_des();

    fprintf(stderr,"salt?: ");
    gets(input);
    strncpy(salt,input,2);
    salt[2] = 0;                /* Safety first :) */
#endif

    (void)srand((int)time((time_t *)NULL));
    to64(&salt[0],rand(),2);

    fprintf(stderr,"password?: ");
    gets(input);
    strncpy(pw,input,8);
    pw[8] = 0;	/* { changed/added 08.08.2003 (20:34) by Ralph Roth } */
    pwe = (char *) crypt(pw,salt);
    fprintf(stderr,"'%s' is encrypted using crypt(): '%s'\n", pw, pwe);

    time(&t);
    strcpy(szTime, ctime(&t));
    // szTime[strlen(szTime)-1] = 0;

    /* if you want to pipe this into a file... */
    printf("guest:%s:1001:200:Guest Account,%s:/home/guest:/bin/ksh\n", pwe, __DATE__);
    to64(&salt[0],rand(),2);
    pwe = (char *) crypt(pw,salt);
    printf("bin:%s:2:2:File System Account etc,%s:/bin:/bin/ksh\n", pwe, __DATE__);

    return 0;

}
