
/****************************************************************************
 * $Header: /home/CVS/c/TinyCrack/Source/tools/merge_loftcrack.c,v 1.5 2003/01/03 15:39:04 ralph Exp $
 *
 * $Log: merge_loftcrack.c,v $
 * Revision 1.5  2003/01/03 15:39:04  ralph
 * ! Makefile enhanced
 * ! y2k3 + copyrigth
 * ! Samba/LM fixes
 *
 * Revision 1.4  2002/04/11 16:17:12  ralph
 * Dos2ux applied
 *
 * Revision 1.3  2002/01/03 12:59:00  ralph
 * Fixed various bugs found in MergePasswords and other tools
 *
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/


/*------------------------------------------------------------------------
 Module:        F:\TinyCrack\Source\tools\merge_loftcrack.c
 Author:        Ralph Roth
 Project:       TinyCrack
 State:         ok
 Creation Date: 8-Aug-2000
 Description:	Merges Loftcrack/Samba password files (unique)
------------------------------------------------------------------------*/
/* L0ftcrack Merger  by ROSE SWE, http://come.to/rose_swe */

static char *_CMSID = "$CmsFile: merge_loftcrack $ $Date: 2003/01/03 15:39:04 $";

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXVALHASH 0x7fff

struct salt_type {
    char user[40], passwdlm[17], passwdnt[17],
    saltlm[56], saltnt[56], probe[40];

    struct salt_type *next;
};

struct salt_type *current, *hash[MAXVALHASH];

long Cnt = 0;

int hashfunc(struct salt_type *s)
{

    char *p;
    int  h;

    p = strchr(s->user, '\\');
    if (p == NULL) p = s->user;
       else p++;

    h = s->user[1];     /* assumes 5 chars min login name! */
    h <<= 4;
    h = h + *p;
    return h &= MAXVALHASH;
}

int exists_hash(struct salt_type *sin)
{
    current = hash[hashfunc(sin)];

    while (current != NULL)
    {
        if ((strcmp(sin->saltlm, current->saltlm) == 0) ||
            (strcmp(sin->saltnt, current->saltnt) == 0))
	{
            return -1;
        }
        current = current->next;
    }

    return 0;

} /* exists_hash() */

void ins_hash(struct salt_type *s)
{

    char        szTmp[256];
    int nHash;

    strcpy(szTmp, s->saltlm);
    strcat(szTmp, s->saltnt);

    if (strstr(szTmp, "0000000000000000") != NULL) return;  /* invalid! */
    if (strstr(szTmp, "1f1f1f1f1f1f1f1f") != NULL) return;  /* invalid! */

    nHash = hashfunc(s);

    if (exists_hash(s) )
        return;


    current = hash[nHash];

    if ((hash[nHash]=malloc(sizeof(struct salt_type)))==NULL)
    {
        puts("\nFATAL: Out of memory! Aborting!");
	exit(2);
    }

    memcpy(hash[nHash], s, sizeof(struct salt_type));
    hash[nHash]->next = current;

    Cnt++;

} /* ins_hash() */


/* reads entire file and puts valid structs into memory */

int read_LoftCrack(char *szSrc)
{
    FILE *hIn;
    static char s[256*2];
    char *p;
    long lCountOld = Cnt;
    struct salt_type  sTmp;

    printf("File: %s \r", szSrc);
    if ((hIn=fopen(szSrc,"r")) == NULL)
        return -1;

    while (!feof(hIn)) {
        fgets(s, sizeof(s), hIn);
        if ((p = strchr(s, '\r')) != NULL) *p = 0;
        if ((p = strchr(s, '\n')) != NULL) *p = 0;
        /* if (!(p = strstr(s, "\":\""))) continue; */
        if ((p = strstr(s, "\":\"")) != NULL) continue;

        strcpy(sTmp.user, strtok(s, ":"));
        strcpy(sTmp.passwdlm, strtok(NULL, ":"));
        strcpy(sTmp.passwdnt, strtok(NULL, ":"));
        strcpy(sTmp.saltlm, strtok(NULL, ":"));
	strcpy(sTmp.saltnt, strtok(NULL, ":"));
        strcpy(sTmp.probe, strtok(NULL, ":\n"));

        if (!exists_hash(&sTmp))
            ins_hash(&sTmp);
    }
    fclose(hIn);

    printf("%s: \t%7ld new passwords added\n", szSrc, Cnt-lCountOld);

    return 0;

}  /* read_LoftCrack() */

void write_LoftCrack(char *szFile)
{
    int   t;
    FILE *hOut;

    if ((hOut=fopen(szFile,"wt")) != NULL)
    {
        fprintf(hOut,
        "LastBruteIteration=0\n" \
        "CharacterSet=1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ\n" \
        "ElapsedTime=0 0\n");

        for (t=0; t<=MAXVALHASH; t++)
        {
            current = hash[t];

            while (current != NULL)
            {
                if (strlen(current->user) > 0)
		   fprintf(hOut, "%s:%s:%s:%s:%s:%s\n", \
                              current->user, current->passwdlm, \
                              current->passwdnt, current->saltlm, \
                              current->saltnt, current->probe);
		current = current->next;
            }
        }
        fclose(hOut);
    }

} /* write_LoftCrack() */


int main(int argc, char *argv[])
{
    char   szFile[256];

    printf("Loftcrack 2.5x Pot Merger by ROSE SWE - http://come.to/rose_swe - (%s)\n$Id: merge_loftcrack.c,v 1.5 2003/01/03 15:39:04 ralph Exp $\n",  __DATE__);
    memset(hash, 0, sizeof(hash));

    if (argc < 2) {
       puts("Usage: L0ftcrack_merge inputfile(s)");
       return 1;
    }

    while (--argc>0) {
          strcpy(szFile, argv[argc]);
          /* printf("Reading file %s\n", szFile); */
          fflush(stdout);
          read_LoftCrack(szFile);
    }
    printf("Writeing back the L0ftcrack pot (all_loft.lc, %ld password) to disc....\n", Cnt);
    write_LoftCrack("all_loft.lc");


    return 0;
}
