/* program:             Mutator for automatic word lists.
                        Use this for a password cracker like Jack or TCrack
   ########################################################################
   04.04.95             Initial creation
   09.07.95             [char_set]
   05.08.95             Copyright + cb
   20.01.96             bugfix, if charset is one char long
 */


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>

char    szMutSet[256];          /* set for mutating */

char GetNext()
{
    int cTmp;

    do {
        cTmp = (rand() % (123-48)) + 48;
        cTmp = tolower(cTmp);

    }
    while (!isalnum(cTmp));

    return((char) cTmp);

} /* GetNext */

int Check4Vowel(char *szWhat)
{
    return (strpbrk(szWhat, "aeiou") != NULL);
}

void GetWord(char *szNew)

{
    char    szTmp[12], c;
    int     nLen, nT;
    nLen = (rand() % 7) + 2;

    do {
        nT   = 0;

looper:
        c = GetNext();
        if (strchr(szMutSet, c) == NULL)
            goto looper;

        if (isdigit(c) && (nT > 2) && (nT < nLen-2))
            goto looper;        /* only at begin or end! */

        szTmp[nT] = c;
        if ((nT > 2) && (szTmp[nT] == szTmp[nT-1]) && (szTmp[nT-1] == szTmp[nT-2]))
            goto looper;        /* no things like: "nnn" or "aaa" */

        nT++;
        szTmp[nT] = 0;

        if (nT < nLen)
            goto looper;


    }
    while (!Check4Vowel(szTmp));

    strcpy(szNew, szTmp);

}

main (int argc, char *argv[]) {


    time_t timer;
    unsigned s;
    char    szPass[15], szPrefix[65];

    if (argc < 2)
    {
        fprintf(stderr, "MUTATI0N LIST GENERAT0R - 0.05 - %s - (C)oded by 1994-2005 by ROSE SWE\n\n", __DATE__);
	fprintf(stderr, "$Id: mutlist.c,v 1.5 2005/01/09 19:06:41 ralproth Exp $\n");
        fprintf(stderr, "usage: %s char_set [prefix]\n\n", argv[0]);
        fprintf(stderr, "char_set is a set of chars/digits which the program uses for mutating.\n");
        exit(1);
    }

    strcpy(szMutSet, argv[1]);
    if (strlen(szMutSet) < 3)
    {
        fprintf(stderr, "\nERROR: Use at least tree chars as a mutation set!\n");
        exit(3);
    }
    if (!Check4Vowel(szMutSet))
    {
        fprintf(stderr, "\nERROR: Use at least one vowel in [char_set]!\n");
        exit(2);
    }

    if (argc > 2)
        strcpy(szPrefix, argv[2]);
    else
        strcpy(szPrefix, "");

    fprintf(stderr,"using '%s' as mutating set and '%s' as prefix...\n",
    szMutSet, szPrefix);

    s = (unsigned) time(&timer);
    srand(s);

    for (s = 1; s < 1000; s++)              /* how many? */
    {
        GetWord(szPass);
        printf("%s%s\n", szPrefix, szPass);
    }

    return 0;
}
