/* $Id: passwd_filter.c,v 1.7 2005/01/09 19:06:41 ralproth Exp $ */
/* Simple driver to copy good passwords (lines of /etc/passwd) to stdout amd bad passwords to stderr */

/*
 * $Log: passwd_filter.c,v $
 * Revision 1.7  2005/01/09 19:06:41  ralproth
 * y2k5 C update
 *
 * Revision 1.6  2004/08/19 22:19:23  ralproth
 * tried some fixes for BSD and MD5 passwords
 *
 * Revision 1.5  2003/12/23 21:44:28  ralproth
 * ! Changed (C)opyright ... -2003 to -2004
 *
 * Revision 1.4  2003/01/03 15:39:06  ralph
 * ! Makefile enhanced
 * ! y2k3 + copyrigth
 * ! Samba/LM fixes
 *
 * Revision 1.3  2002/08/20 17:13:31  ralph
 * more htpasswd fixes
 *
 * Revision 1.2  2002/08/20 16:57:14  ralph
 * Changes/fixes for htpasswd
 *
 * Revision 1.1  2002/04/15 12:24:40  ralph
 * Initial import into WIN CVS
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "lex.yy.c"


int main(int argc, char *argv[])
/* ************************** */
{
    int     nRetCode = 0;
    FILE    *hIn;
    char    szName[256];

    if (strstr(argv[argc-1], "?") != NULL)
    {
        printf("\n(F)LEX Program '%s', created at %s on %s\n", argv[0], __DATE__, __TIME__);
        printf("(C)opyright 1993-2005 by ROSE SWE, Ralph Roth - http://come.to/rose_swe\n\n");
        printf("usage: \t\t%s  input file(s) [>output file]\n\n", argv[0]);
        printf("The input file (standard input default) contains strings and expressions which\n");
        printf("will be copied to standard output by the programm performing a filter function.\n");
        printf("Wildcards are supported and will be expanded. FREEWARE - ALL RIGHTS RESERVED!\n");
        printf("Refer to the documentation or source files for further information!\n\n");
        puts("Main Driver $Id: passwd_filter.c,v 1.7 2005/01/09 19:06:41 ralproth Exp $");
        exit(0);
    }

    if (argc > 1)
    {
        while(--argc > 0)
        {
            strcpy(szName, argv[argc]);
            if ((hIn = fopen(szName, "rt")) == NULL)
            {
                perror(szName);
                fprintf(stderr, "Type  '%s /?'  for a short help!\n", argv[0]);
                exit(1);
            }
            fprintf(stderr,"Processing file: %s\n", szName);
            yyin = hIn;                           /* use file as stdin! */
            yyrestart(yyin);                      /* restart machine */

	    	while ((nRetCode = yylex()) != 0)
		{
			if (nRetCode != BADPWL) /* GOODPWL... */ 
				printf("%s\n", yytext);
			else 			/* (nRetCode == BADPWL) */
				fprintf(stderr,"%s", yytext);	
		};
	    
            fclose(hIn);
            fprintf(stderr,"\n");
        }
    }
    else                                          /* stdin */
        perror("No input files");

    return(nRetCode);
}
