
/****************************************************************************
 * $Header: /home/CVS/c/TinyCrack/Source/tools/shdmerge.c,v 1.3 2002/04/11 16:17:12 ralph Exp $
 *
 * $Log: shdmerge.c,v $
 * Revision 1.3  2002/04/11 16:17:12  ralph
 * Dos2ux applied
 *
 * Revision 1.2  2002/01/03 12:59:00  ralph
 * Fixed various bugs found in MergePasswords and other tools
 *
 *
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/


/* Shadow Merger */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int hashval;

#define allocsize 65536L
#ifndef CRYPT_64BIT
#define alignsize 4
#else
#define alignsize 8
#endif

void *malloc_tiny(size_t size) {
	static char *buffer;
	static size_t bufree = 0;
	char *start;

	if (size <= bufree) {
		start = buffer;
		buffer += size + (alignsize - 1);
		(long)buffer &= (~(alignsize - 1));
		bufree -= buffer - start;
		return start;
	}
	else if (size <= allocsize) {
		if (buffer = (char *)malloc(bufree = allocsize)) return
		    malloc_tiny(size);
		else return NULL;
	}
	else return (void *)malloc(size);
}

struct shadowinfo {
	char *login, *passwd;
	struct shadowinfo *next;
};

int hashfunc(char *login) {
	hashval = 0;
	while (*login) {
		hashval <<= 1;
		hashval ^= *login++;
	}
	hashval ^= hashval >> 8;
	return hashval &= 0xFF;
}


int main(int argc, char **argv) {
	FILE *passwd, *shadow;
	struct shadowinfo *current, *hash[256];
	char s[256], szS[256], szP[256];
	char *p, *pe;


	if (argc != 3) {
		if (argc != 1)
			puts("\nUsage: shadowmerge passwd_file shadow_file [>target_file]");
		else
		{
			strcpy(szP, "/etc/passwd");
			strcpy(szS, "/etc/shadow");
		}
	}
	else
	{
		strcpy(szP, argv[1]);
		strcpy(szS, argv[2]);
	}

	if (!(passwd = fopen(szP, "r"))) {
		printf("ERROR: Unable to open: %s\n", szP);
		return 1;
	}
	if (!(shadow = fopen(szS, "r"))) {
		printf("ERROR: Unable to open: %s\n", szS);
		return 1;
	}

	memset(hash, 0, sizeof(hash));

	while (fgets(s, sizeof(s), shadow)) {
		if (p = strchr(s, '\r')) *p = 0;
		if (p = strchr(s, '\n')) *p = 0;

		if (!(p = strchr(s, ':'))) continue;
		*p++ = 0;
		if (!(pe = strchr(p, ':'))) pe = strchr(p, 0);
		if (pe - p < 1) continue;
		*pe = 0;

		current = hash[hashfunc(s)];
		if (!(hash[hashval] = malloc_tiny(sizeof(struct shadowinfo))) 
		    ||!(hash[hashval]->login = malloc_tiny(strlen(s) + 1)) ||
		    !(hash[hashval]->passwd = malloc_tiny(strlen(p) + 1))) {
			puts("FATAL: Not enough free memory");
			return 1;
		}
		strcpy(hash[hashval]->login, s);
		strcpy(hash[hashval]->passwd, p);
		hash[hashval]->next = current;
	}
	fclose(shadow);

	while (fgets(s, sizeof(s), passwd)) {
		if (p = strchr(s, '\r')) *p = 0;
		if (p = strchr(s, '\n')) *p = 0;

		if (!(p = strchr(s, ':'))) continue;
		*p++ = 0;
		if (!(pe = strchr(p, ':'))) pe = strchr(p, 0);

		if (current = hash[hashfunc(s)]) do
			if (!strcmp(current->login, s)) break;
		while (current = current->next);

		if (current) printf("%s:%s%s\n", s, current->passwd,
		    pe);
		/* else printf("%s:%s\n", s, p);
		*/
	}
	fclose(passwd);

	return 0;
}
