/* simple.c  ---  compares user passwords with dictionary entries */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

/* Function header for crypt */
char *crypt( char *s, char *key );

int main( int argc, char *argv[] )
{
    char s[4096], key[16], uname[256], upasswd[256];
    char fname_passwd[1024], fname_dict[1024];
    char lastone = '\n';
    FILE *fpasswd, *fdict;
    int found, i, j;

    printf( "Username? " );
    gets( uname );
    printf( "Password file? " );
    gets( fname_passwd );
    printf( "Dictionary file? " );
    gets( fname_dict );
    if ( ( fpasswd=fopen( fname_passwd, "r" ) ) == NULL )
    {
        fprintf( stderr, "File %s not found\n", fname_passwd  );
        exit( 1 );
    }
    if ( ( fdict=fopen( fname_dict, "r" ) ) == NULL )
    {
        fprintf( stderr, "File %s not found\n", fname_dict );
        exit( 1 );
    }

    /* Get the user password from fpasswd */
    found = 0;
    do
    {
        fscanf( fpasswd, "%s", s );
        if ( strncmp( s, uname, strlen( uname ) ) == 0 && s[strlen( uname )]==':' )
            found=1;
    }
    while (!found && !feof( fpasswd ) );

    if ( !found )
    {
        fprintf( stderr, "User not found in password file\n" );
        exit( 1 );
    }
    else
    {
        for ( i=0; i<strlen( s ); i++ )
            if ( s[i]==':' ) break;
        i++;
        for ( j=i; j<strlen( s ); j++ )
            if ( s[j]==':' ) break;
        strncpy( upasswd, &s[i], j-i );
        upasswd[j-i]='\0';
        strncpy( key, upasswd, 2 );
        key[2]='\0';
        printf( "User found\n" );
        fclose( fpasswd );
    }

    /* Search for password match */
    found = 0;
    do
    {
        fscanf( fdict, "%s", s );
        if ( strncmp( crypt( s, key ), upasswd, strlen( upasswd ) ) == 0 )
            found=1;
        if ( toupper(lastone) != toupper(s[0]) )
        {
            lastone = toupper(s[0]);
            printf( "%c\r", lastone);
        }
    }
    while (!found && !feof( fdict ) );

    /* If nothing found, try uname as password */
    if ( !found )
    {
        strcpy( s, uname );
        if ( strncmp( crypt( s, key ), upasswd, strlen( upasswd ) ) == 0 )
            found=1;
    }
    if ( found )
        printf( "Password is: %s\n", s );
    else
        printf( "Password not in dictionary\n" );

    fclose( fdict );
    return 0;
}
