/* -----============================================================-----
 *
 *      Programm:       Xtract - Wordlist eXTRACTor
 *      Compiler:       TC 2.00/SCO UNIX/GCC 2.95-3.2
 *      Standards:      ANSI/Hungarian Naming
 *      Project:        Tiny Cracker - UNIX password cracker
 *
 *  -----============================================================-----
 *      Remark:         This program runs on various platform, e.g.
 *                      Win32, DOS, UNIX or OS/2. So DON'T use Borland/MSC
 *                      specific functions. If you have done enhancements
 *                      then please comment them and add date and your
 *                      name below. Then send back the source code to:
 *                                rose_swe@hotmail.com
 *  -----============================================================-----
 *
 *      03.08.95        rar: Initial creation.
 *      15.01.96        rar: Now double word check added.
 *      20.01.96        rar: Check if length < 9.
 *
 *  -----============================================================-----
 */

#include <stdio.h>      /* Ein-/Ausgabe */
#include <stdlib.h>     /* Runtime System */
#include <string.h>     /* String Befehle */
#include <errno.h>      /* Error Handling, perror()... */
#include <ctype.h>      /* tolower() */

/* --- ( Variablen ) --------------------------------------------------- */

FILE    *hIn, *hMut;    /* Handle Input */
char    szWork[1024];   /* Input Line */
char    szMut[1024];
char    szRes[1024];
int     nT;             /* Laufvar */

/* --- ( M A I N ) ----------------------------------------------------- */

int main (int argc, char *argv[])
{
    long	lCount = 0;


    if (argc < 2)
    {
	printf("\nWordlist permutator -=- (c) 1995-2005 by ROSE SWE, Ralph Roth -=- %s\n", __DATE__);
	printf("$Id: wlperm.c,v 1.7 2005/01/09 19:06:41 ralproth Exp $\n");
	printf("\nusage: %s inputfile inputfile(s) [| sort > file]\n", argv[0]);
	exit(1);
    }

    while(argc > 1)
    {
	argc--;
	if ((hIn = fopen(argv[argc], "r")) == NULL)
	{
	    perror(argv[argc]);
	    break;
	}
	if ((hMut = fopen(argv[argc], "r")) == NULL)
	{
	    perror(argv[argc]);
	    break;
	}

	while (!feof(hIn))
	{
	    fscanf(hIn, "%s", szWork);
	    while(!feof(hMut))
	    {
		fscanf(hMut, "%s", szMut);
		if (!(strcmp(szWork, szMut)==0))
		{
		    sprintf(szRes, "%s%s", szWork, szMut);
		    if (strlen(szRes) < 9)
		    {
					    puts(szRes);
					    printf("%s@%s\n", szWork, szMut);
					    printf("%s-%s\n", szWork, szMut);
					    printf("%s %s\n", szWork, szMut);
					    printf("%s_%s\n", szWork, szMut);
					    szMut[0] = toupper(szMut[0]); 
					    printf("%s%s\n", szWork, szMut);
					    lCount += 6;
		    }
		}
	    }
	    rewind(hMut);
	}
	fclose(hIn);
	fclose(hMut);
    }

    fprintf(stderr, "%ld words processed! Please sort them to remove duplicates!\n", lCount);
    return 0;
} /* main */

