/* -----============================================================-----
 *
 *      Programm:       Xtract - Wordlist eXTRACTor
 *      Project:        Tiny Cracker - UNIX password cracker
 *      Compiler:       TC 2.00/SCO UNIX/DJGPP 2.x
 *      Standards:      ANSI/Hungarian Naming
 *
 *  -----============================================================-----
 *      Remark:         This program runs on various platform, e.g.
 *                      DOS, UNIX or OS/2. So DON'T use Borland/MSC
 *                      specific functions. If you have done enhancements
 *                      then please comment them and add date and your
 *                      name below. Then send back the source code to:
 *                                   rar@fh-albsig.de
 *  -----============================================================-----
 *
 *      03.08.1995      rar: Initial creation.
 *      12.12.1995      rar: Fixed "rb" bug, when using bin files.
 *      28.12.1995      rar: Added the Capitalise() function.
 *      18.08.2000      rar: Recompiled using new DJGPP 2.95.2
 *
 *  -----============================================================-----
 */

#include <stdio.h>      /* In-/Output commands */
#include <stdlib.h>     /* Runtime System */
#include <string.h>     /* String commands */
#include <errno.h>      /* Error Handling, perror()... */
#include <ctype.h>      /* tolower() */

/* --- ( Variablen ) --------------------------------------------------- */

#define WORDLENGTH	14

FILE    *hIn;           /* Handle Input */
char    szWork[1024];   /* Input Line */
char    szTmp[1024];
int     nT;             /* Laufvar */

char* Capitalise (char *str)     /* return a pointer to an capitalised */
{
    register char *ptr;
    static char area[255];

    ptr = area;

    while (*str)
    {
        *(ptr++) = (char) tolower (*str);
        str++;
    }

    *ptr = '\0';
    area[0] = (char) toupper (area[0]);
    return (area);
}

void putout(char *szTmp)
{
    szTmp[WORDLENGTH] = 0;       /* only 8 chars relevant to unix's crypt() */

    if ((strlen(szTmp) > 2) && (atol(szTmp) == 0))
    {
        printf("%s\n", szTmp);
        /*
        printf("%s\n", Capitalise(szTmp));
        */
    }
}


/* --- ( M A I N ) ----------------------------------------------------- */

int main (int argc, char *argv[])
{
    if (argc < 2)
    {
        printf("\nWORDLIST EXTRACT0R -=- 1.01 -=- %s -=- (c) 1995-2005 by ROSE SWE\n", __DATE__);
	printf("$Id: wordlist_extract.c,v 1.7 2005/01/09 19:06:41 ralproth Exp $\n");
        printf("\nExtracts words from text files, converting the words to lower case");
        printf("\nand truncates them to %d (max) characters length.", WORDLENGTH);
        printf("\n\a");
        printf("\nusage:   xtract inputfile(s) [morefiles [...]]\n");
        printf("\nE.g.:    xtract wordlist words | sort -uifb > wl\n");
        exit(1);
    }

    while(argc > 1)
    {
        if ((hIn = fopen(argv[--argc], "rb")) == NULL)
        {
            perror(argv[argc]);
            break;
        }

        while (!feof(hIn))
        {

            fscanf(hIn, "%s", szWork);
            strcpy(szTmp, "");

            for (nT = 0; nT < strlen(szWork); nT++)
            {
                szWork[nT] = tolower(szWork[nT]);
                if (isalnum(szWork[nT]))
                    strncat(szTmp,&szWork[nT],1);
                else
                {
                    putout(szTmp);
                    strcpy(szTmp, ""); /* null it */
                }

            }
            strcpy(szWork, szTmp);
            putout(szTmp);
        }

        fclose(hIn);
    }

    return 0;
} /* main */
